package com.cringe_studios.christmastreescanning.scanning;

import java.awt.geom.Point2D;
import java.awt.image.BufferedImage;

import com.cringe_studios.christmastreescanning.scanning.image_scanning.ImageScanner;
import com.cringe_studios.christmastreescanning.scanning.image_scanning.SingleRGBImageScanner;

public class SingleColoredSideScanner extends SideScanner {
	private BufferedImage sideImages[];
	
	private ImageScanner imageScanners[];

	public SingleColoredSideScanner(BufferedImage[] images, byte gammaDelta, Double baseline, Double minX, Double maxX) {
		this(images);

		this.gammaDelta = gammaDelta;
		this.baseline = baseline;
		this.minX = minX;
		this.maxX = maxX;
	}

	// Everything default values
	public SingleColoredSideScanner(BufferedImage[] images) {
		this.sideImages = images;
		
		imageScanners = new SingleRGBImageScanner[images.length];
		
		for(int i = 0; i < images.length; i++) {
			imageScanners[i] = new SingleRGBImageScanner(images[i]);
		}
		
		this.foundPoints = new Point2D[images.length];
	}
	
	@Override
	public void scan() {
		int imagesLength = this.sideImages.length;

		for (int i = 0; i < imagesLength; i++) {
			this.foundPoints[i] = imageScanners[i].getBrightestSpot(gammaDelta);
		}
	}
	
	@Override
	public Point2D[] getPoints() {
		return foundPoints;
	}
}
